 UNIT LowGraph;   { V 2.26 }

 {  (C) fr dieses Unit bei ONKISOFT 1999, das ist Gero Zahn
                                                   Bergring 27
                                                 D-4953 Petershagen
                                                   Tel.: 05707/2501
    Dieses Unit entstand in (mittlerweile) jahrelanger Arbeit, somit
    darf (und soll!) jeder, der es in seinen Programmen verwendet mir
    einen kleinen Unkostenbeitrag (so ca. 10-20 DM) senden. Grundstzlich
    bin ich fr Verbesserungsvorschlge und Bug-Reports immer offen, aber
    ich behalte mir doch vor, Programmnderungen selbst vorzunehmen, damit
    auch unter neuen LOWGRAPH-Versionen alte Programme immer noch laufen,
    denn eine kleine nderung hier oder da kann verherende Wirkungen ganz
    anderswo nach sich ziehen. Also: Meldet Euch einfach!
    Soll LowGraph zusammen mit dem TP-Unit GRAPH verwendet werden, so
    ist es unerllich, das Unit HiGraph zu verwenden. Dadurch, da
    LowGraph zwei Routinen Line und Ellipse bereitstellt, verschwinden
    natrlich die GRAPH-eigenen Prozeduren gleichen namens. HiGraph
    stellt sie unter den Namen Hi_Line und Hi_Ellipse wieder zur
    Verfgung. Das Listing von HiGraph befindet sich am Ende dieses
    Units. }

 interface

 uses crt,dos; { Dos fr REGISTERS und INTR }

 {$R-,S-} { Der Geschwindigkeit wegen }

 CONST aus     = $0F0F; {fr Cursor}
       normcga = $0607;
       normhgc = $0B0D;
       voll    = $000F;

 TYPE zeichentyp=RECORD
                  zeichen:CHAR;
                  farbe  :BYTE;
                 END; { fr bildtyp, ZGet und ZPut }

      bildtyp=ARRAY [1..25,1..80] OF zeichentyp; {fr SGet und SPut }
      bildptr=^bildtyp;

      cardtyp=(HGC,IBM); { fr Card }

 VAR LowMode : (High,Low);  { High heit:  80 * 50 "Punkte",
                              Low  heit: 160 * 25 "Punkte"  }

     scr:bildptr;  { Beinhaltet nach Unit-Start den aktiven Bildschirm }

 PROCEDURE Clear;
 PROCEDURE Conv_NoGra(xn,yn:INTEGER);
 PROCEDURE Cursor(nn:INTEGER);
 PROCEDURE Cursor_Aus;
 PROCEDURE Cursor_Norm;
 PROCEDURE Cursor_Voll;
 PROCEDURE Dot(xd,yd,col:INTEGER);
 PROCEDURE Ellipse(x1,y1,rx,ry,col:INTEGER);
 PROCEDURE Gute_Werte(VAR xxx,yyy:INTEGER);
 PROCEDURE Invert;
 PROCEDURE Kasten(x1,y1,x2,y2,col:INTEGER);
 PROCEDURE Line(x1,y1,x2,y2,col:INTEGER);
 PROCEDURE LoadBild(lname:STRING; VAR error:BOOLEAN);
 PROCEDURE OverPlot(xx,yy:INTEGER);
 PROCEDURE Plot(xp1,yp1:INTEGER);
 PROCEDURE Put(xl,yl:INTEGER;zei:CHAR);
 PROCEDURE SaveBild(sname:STRING; VAR error:BOOLEAN);
 PROCEDURE SGet(VAR bild:bildtyp);
 PROCEDURE SPut(VAR bild:bildtyp);
 PROCEDURE UnPlot(xp1,yp1:INTEGER);
 PROCEDURE VEllipse(x1,y1,rx,ry,col:INTEGER);
 PROCEDURE VKasten(x1,y1,x2,y2,col:INTEGER);
 PROCEDURE XMirror;
 PROCEDURE YMirror;
 PROCEDURE ZGet(xx,yy:INTEGER; VAR zz:zeichentyp);
 PROCEDURE ZPut(xx,yy:INTEGER; zz:zeichentyp);

 FUNCTION Visual:bildptr;
 FUNCTION ASN(xw:REAL):REAL;
 FUNCTION Card:Cardtyp;
 FUNCTION Got(xl,yl:INTEGER):CHAR;
 FUNCTION Groesser(a,b:REAL):REAL;
 FUNCTION Kleiner(a,b:REAL):REAL;
 FUNCTION LowMaxX:INTEGER;
 FUNCTION LowMaxY:INTEGER;
 FUNCTION Plotted(xpl1,ypl1:INTEGER):BOOLEAN;

 implementation

 VAR cscr:bildtyp ABSOLUTE $B800:0000; { CGA-Bildschirm }
     hscr:bildtyp ABSOLUTE $B000:0000; { HGC-Bildschirm }
     fil:FILE OF bildtyp;              { zum Speichern und Laden }
     tas:CHAR;                         { eingelesene Taste }
     karte:cardtyp;                    { aktuelle Grafik-Karte }
     tem:bildptr;
     oldx,oldy:INTEGER;

 FUNCTION Card:Cardtyp; { ergibt die angeschlossene Karte }
  BEGIN
   Card:=karte;
  END;

 FUNCTION Visual:bildptr;
  BEGIN
   CASE card OF IBM : Visual:=@cscr;
                HGC : Visual:=@hscr;
             END;
  END;

 PROCEDURE Cursor(nn:INTEGER);
  VAR regs:Registers;
  BEGIN
   regs.ax := $100;
   regs.cX := nn;
   Intr($10,Regs);
  END;

 PROCEDURE Cursor_Aus;  { Ab sofort keinen Kursor mehr }
  BEGIN
   Cursor(aus);
  END;

 PROCEDURE Cursor_Norm; { normaler Strich-Kursor }
  BEGIN
   IF Card=HGC THEN Cursor(normhgc) ELSE Cursor(normcga);
  END;

 PROCEDURE Cursor_Voll; { Block-Kursor }
  BEGIN
   Cursor(voll);
  END;

 PROCEDURE Clear;
  VAR x,y:BYTE;
      z:zeichentyp;
  BEGIN { Diese Prozedur lscht den gerade aktiven Bildschirm }
   z.zeichen:=' ';
   z.farbe:=TextAttr;
   FOR x:=1 TO 80 DO FOR y:=1 TO 25 DO zput(x,y,z);
   GOTOXY(1,1);
  END;

 FUNCTION ASN(xw:REAL):REAL;
  BEGIN { f(x)=arc sin x }
   IF xw<1 THEN ASN:=ARCTAN(xw/SQRT(1-xw*xw))
    ELSE IF xw=1 THEN ASN:=PI/2 ELSE
     BEGIN
      WRITELN('Illegal argument for ASN!');
      halt;
     END;
  END;

 FUNCTION LowMaxX:INTEGER;
  BEGIN  { Ermittelt Bildschirmbreite in aktiver Auflsung }
   IF LowMode=High THEN LowMaxX:=80 ELSE LowMaxX:=160;
  END;

 FUNCTION LowMaxY:INTEGER;
  BEGIN  { Ermittelt Bildschirmhhe in aktiver Auflsung }
   IF LowMode=High THEN LowMaxY:=50 ELSE LowMaxY:=25;
  END;

 PROCEDURE Gute_Werte(VAR xxx,yyy:INTEGER);
  BEGIN  { Koordinaten-Korrektur, falls irgendein Tlpel vllig irreale
           Werte eingibt oder (z.B.) ein Kreis aus dem Bild herausragt   }
   IF xxx<1 THEN xxx:=1;
   IF yyy<1 THEN yyy:=1;
   IF xxx>LowMaxX THEN xxx:=LowMaxX;
   IF yyy>LowMaxY THEN yyy:=LowMaxY;
  END;

 PROCEDURE Put(xl,yl:INTEGER;zei:CHAR);
  BEGIN { Ein Zeichen irgendwo auf den Bildschirm schreiben:
          Koordinaten xl,yl wie bei GOTOXY(xl,yl)             }
   scr^[yl,xl].zeichen:=zei;
  END;

 PROCEDURE ZPut(xx,yy:INTEGER; zz:zeichentyp);
  BEGIN { hnlich wie Put, doch die Farbe wird mit bertragen }
   scr^[yy,xx]:=zz;
  END;

 FUNCTION Got(xl,yl:INTEGER):CHAR;
  BEGIN { Ein Zeichen irgendwo auf dem Bildschirm auslesen:
          Koordinaten xl,yl wie bei GOTOXY(xl,yl)             }
   Got:=scr^[yl,xl].zeichen;
  END;

 PROCEDURE ZGet(xx,yy:INTEGER; VAR zz:zeichentyp);
  BEGIN  { hnlich wie Got, doch die Farbe wird mit ausgelesen }
   zz:=scr^[yy,xx];
  END;

 PROCEDURE Conv_NoGra(xn,yn:INTEGER);
  BEGIN { Sollte an Stelle (xn,yn) kein Grafik-Zeichen stehen, so wird
          es durch ein Blank plattgemacht                              }
   IF NOT(Got(xn,yn) IN [' ','','','','','']) THEN Put(xn,yn,' ');
  END;

 FUNCTION Groesser(a,b:REAL):REAL;
  BEGIN { Ermittelt das Maximum von a und b }
   a:=ABS(a);
   b:=ABS(b);
   IF a>b THEN Groesser:=a ELSE Groesser:=b;
  END;

 FUNCTION Kleiner(a,b:REAL):REAL;
  BEGIN { Ermittelt das Minimum von a und b }
   a:=ABS(a);
   b:=ABS(b);
   IF a<b THEN Kleiner:=a ELSE Kleiner:=b;
  END;

 PROCEDURE Conv_Coords(xx:INTEGER; VAR high,low:INTEGER);
  BEGIN                      { Grafik-Koordinaten werden (mit Rest)
                         zu Text-Koordinaten konvertiert (fr LowMode=Low)}
   high:=(xx-1) DIV 2+1;
   low:=(xx-1) MOD 2;
  END;

 FUNCTION Plotted(xpl1,ypl1:INTEGER):BOOLEAN;
  VAR ypl,yll:INTEGER;
      xpl,xll:INTEGER;
  BEGIN { Ermittelt, ob ein Punkt auf dem Bildschirm gesetzt ist }
   Gute_Werte(xpl1,ypl1);
   IF LowMode=High THEN
    BEGIN
     Conv_Coords(ypl1,ypl,yll);
     Conv_NoGra(xpl1,ypl);
     IF yll=0 THEN Plotted:=(Got(xpl1,ypl) IN ['',''])
              ELSE Plotted:=(Got(xpl1,ypl) IN ['','']);
    END ELSE
    BEGIN
     Conv_Coords(xpl1,xpl,xll);
     Conv_NoGra(xpl,ypl1);
     IF xll=0 THEN Plotted:=(Got(xpl,ypl1) IN ['',''])
              ELSE Plotted:=(Got(xpl,ypl1) IN ['','']);

    END;
  END;

 PROCEDURE Plot(xp1,yp1:INTEGER);
  VAR yp,yl:INTEGER;
      xp,xl:INTEGER;
  BEGIN { Setzt einen Punkt }
   Gute_Werte(xp1,yp1);
   IF LowMode=High THEN
    BEGIN
     Conv_Coords(yp1,yp,yl);
     Conv_NoGra(xp1,yp);
     IF yl=0 THEN
       IF Got(xp1,yp) IN [' ',''] THEN
          Put(xp1,yp,'') ELSE Put(xp1,yp,'') ELSE
        IF Got(xp1,yp) IN [' ',''] THEN
           Put(xp1,yp,'') ELSE Put(xp1,yp,'');
    END ELSE
    BEGIN
     Conv_Coords(xp1,xp,xl);
     Conv_NoGra(xp,yp1);
     IF xl=0 THEN
       IF Got(xp,yp1) IN [' ',''] THEN
          Put(xp,yp1,'') ELSE Put(xp,yp1,'') ELSE
        IF Got(xp,yp1) IN [' ',''] THEN
           Put(xp,yp1,'') ELSE Put(xp,yp1,'');
    END;
  END;

 PROCEDURE UnPlot(xp1,yp1:INTEGER);
  VAR yp,yl:INTEGER;
      xp,xl:INTEGER;
  BEGIN { Lscht einen Punkt }
   Gute_Werte(xp1,yp1);
   IF LowMode=High THEN
    BEGIN
     Conv_Coords(yp1,yp,yl);
     Conv_NoGra(xp1,yp);
     IF yl=0 THEN
       IF Got(xp1,yp) IN ['',''] THEN
          Put(xp1,yp,'') ELSE Put(xp1,yp,' ') ELSE
        IF Got(xp1,yp) IN ['',''] THEN
           Put(xp1,yp,'') ELSE Put(xp1,yp,' ');
    END ELSE
    BEGIN
     Conv_Coords(xp1,xp,xl);
     Conv_NoGra(xp,yp1);
     IF xl=0 THEN
       IF Got(xp,yp1) IN ['',''] THEN
          Put(xp,yp1,'') ELSE Put(xp,yp1,' ') ELSE
        IF Got(xp,yp1) IN ['',''] THEN
           Put(xp,yp1,'') ELSE Put(xp,yp1,' ');
    END;
  END;

 PROCEDURE OverPlot(xx,yy:INTEGER);
  BEGIN { Invertiert einen Punkt }
   IF Plotted(xx,yy) THEN UnPlot(xx,yy) ELSE Plot(xx,yy);
  END;

 PROCEDURE Dot(xd,yd,col:INTEGER);
  BEGIN { wie Plot, UnPlot und OverPlot, je nach Farbe }
   CASE col OF 0 : UnPlot(xd,yd);
               1 : Plot(xd,yd);
               2 : OverPlot(xd,yd);
             END;
  END;

 PROCEDURE Line(x1,y1,x2,y2,col:INTEGER);
  VAR dx,dxx,dy,dyy,xp,yp:REAL;
  BEGIN { Zeichnet in der angegebenen Farbe (s. Dot) eine "Linie" zwischen
          zwei Punkten }
   dx:=x2-x1;
   dy:=y2-y1;
   dxx:=0;
   dyy:=0;
   IF dx<>0 THEN dxx:=ABS(dx)/Groesser(dx,dy);
   IF dy<>0 THEN dyy:=ABS(dy)/Groesser(dx,dy);
   IF ((dxx=0) AND (dyy=0)) THEN Dot(x1,y1,col)
    ELSE BEGIN
     IF dx<0 THEN dxx:=-dxx;
     IF dy<0 THEN dyy:=-dyy;
     xp:=x1;
     yp:=y1;
     WHILE (ROUND(xp)<>x2) OR (ROUND(yp)<>y2) DO
      BEGIN
       Dot(ROUND(xp),ROUND(yp),col);
       xp:=xp+dxx;
       yp:=yp+dyy;
      END;
     Dot(ROUND(xp),ROUND(yp),col);
    END;
  END;

 PROCEDURE Ellipse(x1,y1,rx,ry,col:INTEGER);  { Eine Ellipse bzw. ein Kreis,
                                                bestimmt durch Mittelpunkt,
                                                X- und Y-Raduis und Farbe   }
  VAR zaehl:INTEGER;
      xx,yy,lasty,ybr:INTEGER;
  PROCEDURE Plotte;
   BEGIN
    Dot(x1+xx,y1+yy,col);
    Dot(x1-xx,y1-yy,col);
    Dot(x1-xx,y1+yy,col);
    Dot(x1+xx,y1-yy,col);
   END;
  BEGIN
   IF rx=0 THEN Line(x1,y1+ry,x1,y1-ry,col);
   IF ry=0 THEN Line(x1+rx,y1,x1-rx,y1,col);
   IF (rx=0) AND (ry=0) THEN Dot (x1,y1,col);
   IF (rx<>0) AND (ry<>0) THEN
    BEGIN
     zaehl:=0;
     lasty:=ROUND(COS(ASN(zaehl/rx))*ry);
     FOR zaehl:=0 TO rx DO
      BEGIN
       xx:=zaehl;
       ybr:=ROUND(COS(ASN(zaehl/rx))*ry);
       FOR yy:=ybr TO lasty DO Plotte;
       lasty:=ybr;
      END;
     Dot(x1+rx,y1,col);
     Dot(x1-rx,y1,col);
     Dot(x1,y1+ry,col);
     Dot(x1,y1-ry,col);
    END;
  END;

 PROCEDURE VEllipse(x1,y1,rx,ry,col:INTEGER); { Eine ausgefllte Ellipse
                                                bzw. ein ausgefllter Kreis }
  VAR zaehl:INTEGER;
      xx,yy:INTEGER;
  PROCEDURE Plotte;
   BEGIN
    Line(x1+xx,y1+yy,x1+xx,y1-yy,col);
    IF xx<>0 THEN Line(x1-xx,y1+yy,x1-xx,y1-yy,col);
   END;
  BEGIN
   IF rx=0 THEN Line(x1,y1+ry,x1,y1-ry,col);
   IF ry=0 THEN Line(x1+rx,y1,x1-rx,y1,col);
   IF (rx=0) AND (ry=0) THEN Dot(x1,y1,col);
   IF (rx<>0) AND (ry<>0) THEN
    BEGIN
     rx:=rx+1;
     FOR zaehl:=0 TO rx-1 DO
      BEGIN
       xx:=zaehl;
       yy:=ROUND(COS(ASN(zaehl/rx))*ry);
       Plotte;
      END;
    END;
  END;

 PROCEDURE Kasten(x1,y1,x2,y2,col:INTEGER); { Ein Rechteck, bestimmt durch
                                              diagonal gegenberliegende
                                              Eckpunkte                     }
  BEGIN
   Line(x1,y1,x2,y1,col);
   Line(x2,y1,x2,y2,col);
   Line(x2,y2,x1,y2,col);
   Line(x1,y2,x1,y1,col);
  END;

 PROCEDURE VKasten(x1,y1,x2,y2,col:INTEGER); { Ein ausgeflltes Rechteck,
                                               Erklrungen bei Kasten     }
  VAR xl:INTEGER;
  BEGIN
   IF x1>x2 THEN
    BEGIN
     xl:=x1;
     x1:=x2;
     x2:=xl;
    END;
   FOR xl:=x1 TO x2 DO
     line(xl,y1,xl,y2,col);
  END;

 PROCEDURE Invert;  { Invertiert die Grafik, sofern mglich
                      (siehe Conv_NoGra) }
  VAR xa,ya:INTEGER;
  BEGIN
   FOR xa:=1 TO 80 DO FOR ya:=1 TO 25 DO
    CASE Got(xa,ya) OF '' : Put(xa,ya,' ');
                       ' ' : Put(xa,ya,'');
                       '' : Put(xa,ya,'');
                       '' : Put(xa,ya,'');
                       '' : Put(xa,ya,'');
                       '' : Put(xa,ya,'');
                     END;
  END;

 PROCEDURE XMirror; { Spiegelt das Bild an der X-Mittellinie }
  VAR h1,h2:zeichentyp;
      xa,ya:INTEGER;
  PROCEDURE convert(VAR was:zeichentyp);
   BEGIN
    CASE was.zeichen OF
          '' : was.zeichen:='';
          '' : was.zeichen:='';
       END;
   END;
  BEGIN
   FOR xa:=1 TO 40 DO FOR ya:=1 TO 25 DO
    BEGIN
     ZGet(xa,ya,h1);
     Convert(h1);
     ZGET(81-xa,ya,h2);
     Convert(h2);
     ZPut(xa,ya,h2);
     ZPut(81-xa,ya,h1);
    END;
  END;

 PROCEDURE YMirror; { Spiegelt das Bild an der Y-Mittellinie }
  VAR h1,h2:zeichentyp;
      xa,ya:INTEGER;
  PROCEDURE convert(VAR was:zeichentyp);
   BEGIN
    CASE was.zeichen OF
          '' : was.zeichen:='';
          '' : was.zeichen:='';
       END;
   END;
  BEGIN
   FOR ya:=1 TO 13 DO FOR xa:=1 TO 80 DO
    BEGIN
     IF ya<>13 THEN
      BEGIN
       ZGet(xa,ya,h1);
       Convert(h1);
       ZGet(xa,26-ya,h2);
       Convert(h2);
       ZPut(xa,ya,h2);
       ZPut(xa,26-ya,h1);
      END ELSE
      BEGIN
       ZGet(xa,ya,h1);
       Convert(h1);
       ZPut(xa,ya,h1);
      END;
    END;
  END;

 PROCEDURE SGet(VAR bild:bildtyp);
  BEGIN  { legt eine Kopie des aktuellen Bildschirms in scr ab }
   bild:=scr^;
  END;

 PROCEDURE SPut(VAR bild:bildtyp);
  BEGIN  { stellt scr auf dem aktuellen Bildschirm dar }
   scr^:=bild;
  END;

 PROCEDURE LoadBild(lname:STRING; VAR error:BOOLEAN);
  VAR lbild:bildtyp;
      Result:WORD;
      undeffil:FILE;
      ll:LONGINT;
  BEGIN                    { Ein Bild wird von Disk geladen.
                             Tritt dabei ein Fehler auf, so wird
                             error TRUE, sonst FALSE              }
   {$I-}
   error:=TRUE;
   ASSIGN(fil,lname);
   RESET(fil);
   result:=IoResult;
   IF result=0 THEN
    BEGIN
     ASSIGN(undeffil,lname);
     RESET(undeffil,1);
     Result:=IoResult;
     ll:=FileSize(undeffil);
     IF Result=0 THEN CLOSE(undeffil);
     IF (ll=4000) AND (result=0) THEN
      BEGIN
       READ(fil,lbild);
       SPut(lbild);
       error:=FALSE;
      END;
     CLOSE(fil);
    END;
   {$I+}
  END;

 PROCEDURE SaveBild(sname:STRING; VAR error:BOOLEAN);
  VAR sfil:FILE OF bildtyp;
      sbild:bildtyp;
  BEGIN                    { Das Bild wird auf Disk gespeichert.
                             Tritt dabei ein Fehler auf, so wird
                             error TRUE, sonst FALSE              }
   {$I-}
   SGet(sbild);
   ASSIGN(sfil,sname);
   REWRITE(sfil);
   WRITE(sfil,sbild);
   CLOSE(sfil);
   error:=(IoResult<>0);
   {$I+}
  END;

 PROCEDURE analysiere_karte;
  VAR hz,cz:zeichentyp;
      xp,yp:BYTE;
  BEGIN
   hz:=hscr[1,1];
   cz:=cscr[1,1];
   xp:=WHEREX;
   yp:=WHEREY;
   hscr[1,1].zeichen:=' ';
   GOTOXY(1,1);
   WRITE('*');
   IF hscr[1,1].zeichen='*' THEN karte:=HGC ELSE karte:=IBM;
   GOTOXY(xp,yp);
   hscr[1,1]:=hz;
   cscr[1,1]:=cz;
  END;

BEGIN
 CheckBreak:=TRUE;
 analysiere_karte;
 scr:=Visual;
 LowMode:=High;
 IF karte=IBM THEN
  BEGIN
   NEW(tem);
   SGET(tem^);
   oldx:=WHEREX;
   oldy:=WHEREY;
   TextMode(CO80);
   SPUT(tem^);
   GOTOXY(oldx,oldy);
   DISPOSE(tem);
  END;
END.

{ Hier nun das Hilfs-Unit HiGraph. Einfach mit Block-Write ausschneiden
  und separat compilieren.
---------------------------------------------------------------
UNIT HiGraph;

 INTERFACE

 uses graph;

  PROCEDURE Hi_Line(x1,y1,x2,y2:INTEGER);
  PROCEDURE Hi_Ellipse(X,Y:INTEGER; StAngle,EndAngle:WORD;
                       XRadius,YRadius:WORD);

 IMPLEMENTATION

  PROCEDURE Hi_Line(x1,y1,x2,y2:INTEGER);
   BEGIN
    Line(x1,y1,x2,y2);
   END;

  PROCEDURE Hi_Ellipse(X,Y:INTEGER; StAngle,EndAngle:WORD;
                       XRadius,YRadius:WORD);
   BEGIN
    Ellipse(X,Y,StAngle,EndAngle,XRadius,YRadius);
   END;

  END.
--------------------------------------------------------------}